import type { Generic } from 'adopted-style-sheets';
import type { Loading, PropImageSource } from '../props';
type RequiredProps = {
    alt: string;
} & PropImageSource;
type OptionalProps = {
    loading: Loading;
    sizes: string;
    srcset: string;
};
type RequiredStates = RequiredProps & {
    loading: Loading;
};
type OptionalStates = {
    sizes: string;
    srcset: string;
};
export type ImageProps = Generic.Element.Members<RequiredProps, OptionalProps>;
export type ImageStates = Generic.Element.Members<RequiredStates, OptionalStates>;
export type ImageAPI = Generic.Element.ComponentApi<RequiredProps, OptionalProps, RequiredStates, OptionalStates>;
export {};
